<template>
	<view class="uni-page-modal-5601">
		<!-- 表头样式 -->
		<OIForm ref="refBaseForm" class="v-headStyle" :form="head_styledef.form" :focusId="focusFieldId"
			@on-click="onClick" @on-focus="ontap" @on-change="onEnterChange" @on-click-prefix="classAttr_extButton"
			@on-click-suffix="classAttr_extButton"></OIForm>

		<view class="view-content">
			<!-- 码盘子界面 -->
			<view v-if="param.Show_Welcom_Page==false" class="uni-panel-content">
				<!-- 页签 -->
				<view class="dv-tab">
					<uni-segmented-control :current="current" :values="tabs" @clickItem="onClickItem"
						styleType="button">
					</uni-segmented-control>
				</view>
				<swiper class="view-tabpage" :current="current" @change="changeSwiper">
					<!-- 子界面 -->
					<swiper-item v-for="(pageData, pageIndex) in pageDetail" :key="pageIndex">
						<view class="uni-panel-content">
							<view class="view-tab-content" :id="'tabpanel' + pageData.Name">
								<image class="logo" v-if="pageData.DefList.length==0"
									src="../../images/mobox_log_200x40.png">
								</image>
								<checkbox-group @change="checkboxChange">
									<div class="dv-panel" v-for="(style,ii) in pageData.DefList" :key="ii"
										@tap="onPanelClick(ii,style.form.htmlobjId)"
										:id="'dvpanel'+style.form.htmlobjId"
										:class="style.form.htmlobjId==active_id?'bk-active':''">
										<OIForm class="dv-panel-form" :form="style.form" viewMode></OIForm>
										<div class="dv-panel-button"
											v-if="pageData.Select_Button==true || pageData.Row_Button.length > 0">

											<checkbox v-if="pageData.Select_Button==true" :value="ii"
												:checked="style.SelBut_Checked" />
											<!-- <text></text> -->
											<!-- <button type="primary" @click="savaItem(ii)" v-if="param.Sub_Page[0].OK_Button==true">保存</Button> -->
											<button size="mini" v-for="(btn,btnIndex) in pageData.Row_Button"
												:key="btnIndex" type="default"
												:class="btn.FunCode == 'Delete' ? 'btn-warn' : 'btn-primary'"
												@click="onRowBtnClick(btn, pageData,ii)">
												<text v-if="btn.Style == 'img' || btn.Style == 'img_text'"
													class="Img"></text>
												{{(btn.Style == 'text'|| btn.Style == 'img_text') ? btn.ShowName :""}}
											</button>
										</div>

									</div>
								</checkbox-group>
							</view>
							<view class="view-bottom" v-if="pageData.Button.length >0 ">
								<button v-for="(btn,btnIndex) in pageData.Button" :key="btnIndex" type="default"
									:class="{'btn-primary':(btn.FunCode != 'Cancel'),
										'btn-cancel':(btn.FunCode == 'Cancel'),
										'btn-one':pageData.Button.length == 1,
										'btn-left':(btnIndex < pageData.Button.length - 1),
										'btn-right': btnIndex > 0 && btnIndex == pageData.Button.length - 1 ,
										'width-50':(pageData.Button.length == 2),'width-32':(pageData.Button.length == 3),'width-30':(pageData.DropDownButton.length> 0)}" @click="onBtnClick(btn, pageData)">
									<text v-if="btn.Style == 'img' || btn.Style == 'img_text'" class="Img"></text>
									{{(btn.Style == 'text'|| btn.Style == 'img_text') ? btn.ShowName :""}}
								</button>
								<view class="btn-right" v-if="pageData.DropDownButton.length >0 ">
									<a @click="clickDropdownBtns(pageData)">
										<text class="mobox-normal-more"></text>
									</a>
								</view>
							</view>
						</view>
					</swiper-item>
				</swiper>
			</view>
			<!-- 图文/文本 -->
			<view class="view-imagetext" v-else>
				<div class="view-imagetext-uploadlist">
					<image :src="param.Welcome_Page.Img"
						:style="{'width':param.Welcome_Page.Width+'px','height':param.Welcome_Page.Height+'px'}">
					</image>
					<text class="txt-text"
						:style="{'color':param.Welcome_Page.Txt_Color,'font-size':param.Welcome_Page.Font_Size+'px','font-family':param.Welcome_Page.Font}">{{param.Welcome_Page.Text}}</Text>
				</div>
			</view>
		</view>
		<view>
			<uni-popup class="view-popup" ref="popup" background-color="#fff" @change="popupChange">
				<view class="popup-header">{{check_list.title}}</view>
				<view class="popup-content" :class="{ 'popup-height': popupType === 'left' || popupType === 'right' }"
					:style="{'width':check_list.width?check_list.width+'px':'375rpx','height':check_list.height?check_list.height+'px':popupType =='center'?'60vh':'88vh'}">
					<view class="popup-cont"
						:style="{'height':check_list.height?check_list.height-45+'px':popupType =='center'?'50vh':'80vh'}">
						<view class="view_popup_CheckList" v-for="(item,index) in check_list.items">
							<checkbox-group class="check_list" @change="checkChange" :data-ischeck="item.check"
								:data-index="index" :style="{'margin-left': '10rpx'}">
								<label>
									<checkbox :value="item.check" :checked="item.check" />
									<text>{{item.name}}</text>
								</label>
							</checkbox-group>
						</view>
					</view>
					<view class="popup-footer">
						<button type="default" @tap="popup_sava" class="btn_popup_add">{{translateSys('ok')}}</button>
						<button type="default" @tap="popup_cancel"
							class="btn_popup_cancel">{{translateSys('cancel')}}</button>
					</view>
				</view>
			</uni-popup>
		</view>
	</view>
</template>

<script>
	import {
		Base64
	} from '@/js/Base64.js';
	import {
		dictGetInfo
	} from "@/api/mobox.js"
	import {
		getUIStyleInfo,
		runCustomEvent,
	} from "@/api/data.js"
	import dayjs from "dayjs";
	import OIForm from '@/components/oi-form/index.vue'
	import OIFormItem from '@/components/oi-form/list/index.vue'
	import OIFormInput from '@/components/oi-form/list/input/index.vue'
	import OIFormInputNumber from '@/components/oi-form/list/input-number/index.vue'
	import buttonClickMixin from '@/mixins/button-click.js';

	export default {
		name: "PageModal5601",
		mixins: [buttonClickMixin],
		components: {
			OIForm,
			OIFormItem,
			OIFormInput,
			OIFormInputNumber

		},

		data() {
			return {
				title: this.translateSys("inventory"),
				ClsID: '',
				param: {},
				focusFieldId: "",
				focusOldFieldId: "",
				head_styledef: {
					form: {
						items: []
					}
				},
				pageDetail: [], //{StyleDef{}:,DefList:[],ExtData:{}}
				// 分段器数据
				current: 0,
				After_OK_Event: {},
				active_id: '',
				selectAttrObj: {},

				global_attr: [],
				popupType: "center",
				check_list: {},
				popupParam: {},
			};
		},
		computed: {
			tabs() {
				return this.pageDetail.map((page => {
					return page.Name
				}));


			},
		},
		onLoad(options) {
			uni.setNavigationBarTitle({
				title: options.titlename
			}); //设置顶部标题 
			this.title = options.titlename;
			this.param = JSON.parse(options.param);
			//获取主数据类ID
			this.ClsID = this.param.master_cls?.id;
			if (this.ClsID) {
				this.loadData(options.paramValue)
			} else {
				uni.showModal({
					title: this.translateSys("error"),
					content: this.translate("tip_no_master_class"),
					showCancel: false,
					confirmText: this.translateSys('close')
				});
			}
		},
		//页面初始化获取焦点
		methods: {
			setData(obj) {
				let that = this;
				let keys = [];
				let val, data;

				Object.keys(obj).forEach(function(key) {
					keys = key.split(".");
					val = obj[key];
					data = that.$data;
					keys.forEach(function(key2, index) {
						if (index + 1 == keys.length) {
							that.$set(data, key2, val);
							console.log("$set", key2, val)
						} else {
							if (!data[key2]) {
								that.$set(data, key2, {});
								console.log("$set", key2, {})
							}
						}
						data = data[key2];
					});
				});
			},
			async loadData(paramValue) {
				//获取数据类的自定义表单参数
				await this.Head_UIStyleGetInfo(this.ClsID, this.param.Input_UI_Style.ID);
				//传入参数值
				if (paramValue) {
					const attrs = paramValue.attrs || [];
					(this.head_styledef?.form?.items || []).forEach(async (ele, index) => {
						if (ele.name != "Layout") {
							attrs.forEach(async (ele2, index2) => {
								if (ele.fieldId == ele2.name) {
									ele.value = ele2.value;
								}
							});
						} else {
							ele.setting.colList.forEach(async (col) => {
								if (col) {
									attrs.forEach(async (ele2,
										index2) => {
										if (col.fieldId == ele2.name) {
											col.value = ele2.value;
										}
									});
								}
							});
						}
					})
				}
				//加载初始界面
				if (this.param.Show_Welcom_Page) {
					this.param.Welcome_Page.Img = this.param.Welcome_Page.Img.replace(/ /g, '+');
					this.param.Welcome_Page.Width = parseInt(this.param.Welcome_Page.Width);
					this.param.Welcome_Page.Height = parseInt(this.param.Welcome_Page.Height);
				};
				//加载Tab页签
				const pageList = this.param.Sub_Page || []
				for (let i in pageList) {

					const page = pageList[i]
					page.DefList = [];
					page.StyleDef = await this.Detail_UIstyleGetInfo(
						this.ClsID,
						page.UI_Style.ID
					);
					const buttons = this.pageButtonList(page)
					page.Button = buttons
					page.DropDownButton = []
					if (buttons.length > 3) {
						let cancelBtn = undefined
						const btns = []
						buttons.forEach((btn) => {
							if (btn.FunCode == "Cancel") {
								cancelBtn = btn
							} else {
								btns.push(btn)
							}
						})
						if (cancelBtn) {
							if (btns.length > 2) {
								page.DropDownButton = btns.splice(2)
								page.Button = btns
							}
							page.Button.push(cancelBtn)
						} else {
							if (btns.length > 3) {
								page.DropDownButton = btns.splice(3)
								page.Button = btns
							}
						}
					}
					page.Row_Button = this.rowButtonList(page)
				}

				this.setData({
					pageDetail: pageList
				})

				console.log(this.pageDetail);
			},
			changeSwiper(evt) {
				let index = evt.target.current || evt.detail.current;
				this.setData({
					current: index
				})
			},
			pageButtonList(page) {
				if (this.param?.ver == "2.0") {
					return page?.Button || []

				} else {
					if (page?.OK_Button) {
						let evt = {};
						if (page.Before_ok?.ID) {
							evt = {
								ID: page.Before_ok?.ID,
								Name: page.Before_ok?.Name
							};
						} else if (page.After_ok?.ID) {
							evt = {
								ID: page.After_ok?.ID,
								Name: page.After_ok?.Name
							};
						}
						let btnCancel = {
							Cls_Name: this.param?.master_cls?.name || "",
							Cls_ID: this.param?.master_cls?.id || "",
							FunCode: "Cancel",
							ShowName: this.$t("sys.cancel"),
							Style: "text",
							Prompt: false,
						};
						if (evt.ID) {
							let btn = {
								Cls_Name: this.param?.master_cls?.name || "",
								Cls_ID: this.param?.master_cls?.id || "",
								FunCode: "TriggerEvent",
								ShowName: this.$t("sys.ok"),
								Style: "text",
								Prompt: false,
								NotTriggerSYSEvent: false,
								DataStateVerify: false,
								AttrVerify: false,
								Event: evt,
							};
							if (page.After_ok?.ID) {
								btn.After_Event = page.After_ok;
							}
							return [btn, btnCancel];
						} else return [btnCancel];
					} else {
						return [];
					}
				}
			},
			rowButtonList(page) {
				if (this.param?.ver == "2.0") {
					return page?.Row_Button || [];
				} else {
					if (page?.Del_Button) {
						let evt = {};
						if (page.Before_Delete?.ID) {
							evt = {
								ID: page.Before_Delete?.ID,
								Name: page.Before_Delete?.Name,
							};
						} else if (page.After_Delete?.ID) {
							evt = {
								ID: page.After_Delete?.ID,
								Name: page.After_Delete?.Name
							};
						}
						return [{
							Cls_Name: this.param?.master_cls?.name || "",
							Cls_ID: this.param?.master_cls?.id || "",
							FunCode: "Delete",
							ShowName: this.$t("sys.delete"),
							Style: "text",
							Prompt: false,
							NotTriggerSYSEvent: false,
							DataStateVerify: false,
							AttrVerify: false,
							AfterProcess_Event: evt,
						}];
					}
					return [];
				}
			},

			checkboxChange(e) {

				var items = this.pageDetail[this.current]?.DefList || []
				var values = e.detail.value;
				for (var i = 0, lenI = items.length; i < lenI; ++i) {
					const item = items[i]
					if (values.includes(i)) {
						item.SelBut_Checked = true
					} else {
						item.SelBut_Checked = false
					}
				}
			},
			async Head_UIStyleGetInfo(class_id, style_id) { //获取自定义表单样式
				try {
					var $this = this;
					var dataInfo = {
						class_id: class_id,
						ui_style_id: style_id,
					};
					const result = await getUIStyleInfo(dataInfo)
					var styledef = "";
					if (result.style_def) {
						//mobox2的style_def是json字符串
						styledef = result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!result.style_def.includes('"')) styledef = Base64.decode(
							result
							.style_def);
					}
					const styledefHead = styledef ? JSON.parse(styledef) : {};
					if (styledefHead?.form?.items) {
						for (let i in styledefHead.form.items) {
							const ele = styledefHead.form.items[i]
							if (ele.name != "Layout") {
								if (ele?.useDict) {
									//判断useDict是否使用字典
									await this.DictGetInfo(ele.bind.dict,
										styledefHead.form.model,
										ele);
								} else {
									if (ele?.name === "Select") {
										const selections = ele?.selections || []
										//有默认值，显示默认值
										let itemName = ele.value || "";
										if (itemName) {
											styledefHead.form
												.model[ele.fieldId] = itemName;
										}

										ele.selections = selections.map((a) => {
											return {
												value: a.value,
												text: a.label
											}
										})

									}

								}

								if ($this.focusFieldId == "") {
									if (ele.name == 'Input' || ele.name ==
										'InputNumber') {
										$this.setData({
											focusFieldId: ele.fieldId
										})
									}
								}
							} else {
								for (let j in ele.setting.colList) {
									const col = ele.setting.colList[j]
									if (col?.useDict) {
										//判断useDict是否使用字典
										await this.DictGetInfo(col.bind
											.dict,
											styledefHead.form
											.model, col);
									} else {
										if (col?.name === "Select") {
											const selections = col?.selections || []
											//有默认值，显示默认值
											let itemName = col.value || "";
											if (itemName) {
												styledefHead.form
													.model[col.fieldId] = itemName;
											}
											col.selections = selections.map((a) => {
												return {
													value: a.value,
													text: a.label
												}
											})
										}
									}
									if ($this.focusFieldId == "") {
										if (col.name == 'Input' || col
											.name ==
											'InputNumber') {
											$this.setData({
												focusFieldId: col
													.fieldId
											})
										}
									}
								}
							}
						}

					}
					this.setData({
						head_styledef: styledefHead
					})
					console.log("Head_UIStyleGetInfo", this.head_styledef)

				} catch (ex) {
					// console.log(ex);
					uni.showModal({
						title: this.translateSys("error") + "1",
						content: ex.errMsg,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return {}
				}


			},
			async Detail_UIstyleGetInfo(class_id, style_id) { //获取自定义表单样式
				try {
					var $this = this;
					var dataInfo = {
						class_id: class_id,
						ui_style_id: style_id,
					};
					const result = await getUIStyleInfo(dataInfo)
					var styledef = "";
					if (result.style_def) {
						//mobox2的style_def是json字符串
						styledef = result.style_def.replace(/\\/g, "");
						//mobox3的style_def是base64字符串
						if (!result.style_def.includes('"')) styledef = Base64
							.decode(result
								.style_def);
					}

					const detailstyledef = result.style_def ? JSON.parse(
						styledef) : {};
					detailstyledef.SelBut_Checked = true;
					if (detailstyledef?.form?.items) {
						for (let index in detailstyledef.form.items) {
							const ele = detailstyledef.form.items[index]

							if (ele.name != "Layout") {
								if (ele.useDict == true) { //判断useDict是否使用字典
									await this.DictGetInfo(ele.bind.dict,
										detailstyledef.form
										.model, ele);
								} else {
									if (ele?.name === "Select") {
										ele.selections = []
									}
								}

							} else {
								for (let j in ele.setting.colList) {
									const col = ele.setting.colList[j]
									if (col?.useDict == true) {
										await this.DictGetInfo(col
											.bind.dict,
											detailstyledef.form
											.model, col);
									} else {
										if (col?.name === "Select") {
											col.selections = []
										}
									}
								}
							}
						}

					}
					console.log("Detail_UIstyleGetInfo", detailstyledef);
					return detailstyledef
				} catch (ex) {
					// console.log(ex);
					uni.showModal({
						title: this.translateSys("error") + "2",
						content: ex.errMsg,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return {}
				}


			},

			async DictGetInfo(dict, formModel, formItem) { //Mobox3得到得到字典信息字典项列表
				this.data = [];
				var $this = this;
				var dataInfo = {
					dict_id: dict.id,
					dict_name: dict.name
				};
				try {
					const result = await dictGetInfo(dataInfo)
					var list = [];
					var itemName = '';
					(result.dict_item_list || []).forEach((item) => {
						if (item.is_default == '1')
							itemName = item.name
						list.push({
							text: item.value ? item.value : item.name,
							value: item.name,
						});
					});
					//有默认值，显示默认值
					if (itemName) {
						formItem.value = itemName;
						formModel[formItem.fieldId] = itemName;
					}
					formItem.dict = list;
				} catch (ex) {
					// console.log(ex);
					uni.showModal({
						title: this.translateSys("error") + "3",
						content: ex.errMsg,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}

			},
			onClick(item) {
				console.log("onClick", item)
				this.focusFieldId = item.fieldId
			},
			ontap(item) { //扫码功能
				// var $ele = e;
				//console.log(e.target)
				this.focusOldFieldId = item.fieldId
				getApp().onScan((result) => {
					console.log(result.decodedata);
					item.value = result.decodedata;
					var $this = this;
					let newVal = item.value.trim()
					if (newVal) {
						item.oldvalue = newVal;
						var attr = item.fieldId;
						this.head_styledef.form.model[attr] = newVal;
						var onChangeEvent = item.bind.onChangeEvent; //内容变化后事件
						var onSuffixClickCallbackEvent = item.bind
							.onSuffixClickCallbackEvent; //后图标点击事件
						var onSuffixClickEvent = item.bind
							.onSuffixClickEvent; //后图标点击回调
						var isflag = false;

						if (onChangeEvent?.id) { //内容变化后事件
							$this.onChange(onChangeEvent);
						}

						//初始化，下个输入框focus属性
						var findd = false
						for (let i in $this.head_styledef.form.items) {
							const ele = $this.head_styledef.form.items[i]

							if (ele.name != "Layout") {
								if (ele.name == 'Input' || ele.name ==
									'InputNumber') {
									if (attr == ele.fieldId) {
										findd = true
									} else {
										if (findd) {
											$this.setData({
												focusFieldId: ele.fieldId
											})
											break
										}

									}

								}
							} else {
								if (findd) {
									let curIndex = ele.setting.colList.findIndex((
										col, index2, arr) => {
										return (col.name == 'Input' || col
											.name == 'InputNumber');
									})
									if (curIndex > -1) {
										$this.setData({
											focusFieldId: ele.setting
												.colList[curIndex]
												.fieldId
										})
										break
									}

								} else {
									let curIndex = ele.setting.colList.findIndex((
										col, index2, arr) => {
										return attr == col.fieldId;
									})
									if (curIndex > -1) {
										findd = true
										let curIndex2 = ele.setting.colList
											.findIndex((col, index2, arr) => {
												return (col.name == 'Input' ||
														col.name ==
														'InputNumber') &&
													index2 >
													curIndex;
											})
										if (curIndex2 > -1) {
											$this.setData({
												focusFieldId: ele.setting
													.colList[curIndex]
													.fieldId
											})
											break
										}
									}
								}

							}
						}
					}
				})
			},

			onEnterChange(item) { //回车，点击按钮，取消节点事件
				console.log(item);
				let newVal = item.value
				if (typeof item.value == "string") {
					newVal = item.value.trim()
					if (!newVal) {
						item.oldvalue = newVal;
						var attr = item.fieldId;
						this.head_styledef.form.model[attr] = newVal;
						return
					}

				}
				if (item.oldvalue != newVal) {
					item.oldvalue = newVal;
					var attr = item.fieldId;
					this.head_styledef.form.model[attr] = newVal;
					var onChangeEvent = item.bind.onChangeEvent; //内容变化后事件
					if (onChangeEvent?.id) { //内容变化后事件
						this.onChange(onChangeEvent);
					}

				}
			},

			classAttr_extButton(item) {
				var onSuffixClickCallbackEvent = item.bind.onSuffixClickCallbackEvent; //后图标点击事件
				var onSuffixClickEvent = item.bind.onSuffixClickEvent; //后图标点击回调

				if (!onSuffixClickCallbackEvent.id) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate('icon_click_callback_empty'),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				if (!onSuffixClickEvent.id) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate('icon_click_event_empty'),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				this.popupType = 'right'
				// open 方法传入参数 等同在 uni-popup 组件上绑定 type属性
				this.$refs.popup.open(this.popupType);

				this.dataObjRunCustomEvent_Return(onSuffixClickEvent.id, '', onSuffixClickCallbackEvent.id,
					item);
			},

			getDetailAttrList(pageData) {
				const detailAttrList = [];
				console.log(pageData)
				if (pageData.DefList) {
					pageData.DefList.forEach(style => {
						var detail_attr = {};
						style.form.items.forEach(item => {
							if (item.name == "Layout") { //判断是否是栅栏格式
								item.setting.colList.forEach(col => {
									if (col != null) detail_attr[col
										.fieldId] = col.value;
								});
							} else
								detail_attr[item.fieldId] = item.value;
						});

						detail_attr['id'] = style.form.objId;
						if (pageData.Select_Button == true) { //判断选择按钮是否为true
							if (style.SelBut_Checked == true)
								detailAttrList.push(detail_attr);
						} else
							detailAttrList.push(detail_attr);
					});
					// console.log(detailAttrList);
					//获取正在码盘里没有显示的字段
					pageData.DefList.forEach(style => {
						style.form.attrs.forEach(attr => {
							for (var key in detailAttrList) {
								if (style.form.objId == detailAttrList[key][
										'id'
									]) {
									var keys = Object.keys(detailAttrList[key]);
									var isflag = true;
									keys.forEach((ele) => {
										if (ele == attr.attr) isflag =
											false;
									});
									if (isflag) {
										detailAttrList[attr.attr] = attr.value;
									}
								}
							}
						});
					});
				}
				console.log(detailAttrList)
				const jsonlist = [];
				detailAttrList.forEach(attr => {
					jsonlist.push({
						id: attr["id"] || "",
						attrs: Object.keys(attr).map((a) => ({
							attr: a,
							value: attr[a] || "",
						})).filter((a) => {
							return a.attr != "id"
						})
					});
				});
				return jsonlist;
			},
			// 内容变化后事件
			async onChange(event) {
				try {
					if (event.id) {
						//获取表头属性
						var head_attr = {};
						this.head_styledef.form.items.forEach(item => {
							if (item.name == "Layout") { //判断是否是栅栏格式
								item.setting.colList.forEach(col => {
									if (col != null) head_attr[col
										.fieldId] = col.value;
								});
							} else
								head_attr[item.fieldId] = item.value;
						});
						var obj_attr = this.head_styledef.form.model;
						// console.log(obj_attr);

						var input_param = Base64.encode(
							JSON.stringify(
								Object.keys(head_attr).map((a) => ({
									attr: a,
									value: head_attr[a] || "",
								}))
							)
						);
						var $this = this;
						const jsonList = []
						this.pageDetail.forEach((page) => {

							jsonList.push({
								page_name: page.Name,
								item_list: $this.getDetailAttrList(page),
								ext_data: page.ExtData || {}
							})

						})
						const data_json = Base64.encode(
							JSON.stringify(jsonList)
						);
						console.log(jsonList)
						var dataInfo = {
							ed_type: 0,
							start_transaction: true,
							class_id: this.head_styledef.form.clsId,
							class_name: '',
							event_id: event.id,
							event_name: '',
							data_obj_id: '',
							obj_attr: obj_attr,
							prj_id: '',
							ref_cls_id: '',
							rel_obj_id: '',
							user_login: '',
							data_json: data_json,
							compose_info: '',
							ext_info: '',
							global_attr: '',
							input_param: input_param,
						};
						runCustomEvent(dataInfo).then(result => {
							console.log(result);
							if (result.ret != 0) {
								var tip = result.err_info ? typeof result
									.err_info == 'string' ? result
									.err_info : result.err_info.join('<br/>') :
									'';
								if (result.ret == 801) {
									if (this.param.Only_Script_Error) {
										let pos = tip.indexOf("：");
										if (pos > -1) tip = tip.substring(pos +
											1);
									}
									uni.showModal({
										title: this.translateSys(
											"tip"),
										content: tip,
										showCancel: false,
										confirmText: this.translateSys(
											'close')
									});
								} else uni.showModal({
									title: this.translateSys('tip'),
									content: tip + ',' + this
										.translateSys('tip') + ':' +
										result
										.ret,
									showCancel: false,
									confirmText: this.translateSys(
										'close')
								});
								return false;
							} else {
								var tip = result.info ? typeof result.info ==
									'string' ? result.info :
									result.info.join('<br/>') : '';
								if (tip) uni.showModal({
									title: this.translateSys('tip'),
									content: tip,
									showCancel: false,
									confirmText: this.translateSys(
										'close')
								});

								if (result.result_type == 0 && result.action) {
									result.action.forEach(item => {
										if (item.action_type == "insert_subtable_page_row") { //码盘中
											$this.param.Show_Welcom_Page = false;
											var value = item.value;
											$this.viewAceionRow(value);
										} else if (item.action_type ==
											"set_subtable_page_content") { //已码盘
											$this.param.Show_Welcom_Page = false;
											var value = item.value;
											const pageData = $this.pageDetail.find((page) => {
												return value.page_name == page.Name;
											});
											if (value.clear_confirm != false && value.clear == true &&
												pageData && pageData.DefList.length > 0
											) { //判断是否清空页签内容,正在码盘是否有数据
												uni.showModal({
													title: this.translateSys('tip'),
													content: this.translate(
															"are_you_sure_clear_first") +
														this.translateSys(
															"quotation_mark_left") +
														value.page_name +
														this.translateSys(
															"quotation_mark_right") +
														this.translate(
															"are_you_sure_clear_last"),
													cancelText: $this.translateSys('ok'),
													confirmText: $this.translateSys('cancel'),
													success: function(res) {
														if (res.cancel) {
															if (pageData)
																pageData.DefList = [];
															$this.viewAceionContent(value);
														} else if (res.confirm) {
															if (pageData)
																pageData.DefList = [];
															$this.viewAceionContent(value);
														}
													}
												});
											} else {
												if (pageData)
													pageData.DefList = [];
												$this.viewAceionContent(value);
											}
										} else if (item.action_type == "select_subtable_page") {
											var value = item.value;
											const pageIndex = $this.pageDetail.findIndex((page) => {
												return value.page_name == page.Name;
											});
											if (pageIndex > -1) {
												$this.setData({
													current: pageIndex
												})
											}
										} else if (item.action_type == "select_subtable_page_row") {
											// value = {"page_name":"码盘中", "row":{"id":"xx"}}
											var value = item.value;
											$this.viewActionSelectRow(value)
										} else if (item.action_type ==
											"remove_subtable_page_row") { //清除面板中指定id的数据
											var value = item.value;
											$this.viewActionRemoveRow(value)
										} else if (item.action_type == "set_subtable_page_row") {
											$this.viewActionSetRow(item.value)

										} else if (item.action_type == "set_subtable_page_ext_data") {
											var value = item.value;
											const pageData = $this.pageDetail.find((page) => {
												return value.page_name == page.Name;
											});
											if (pageData)
												pageData.ExtData = value.ext_data

										} else if (item.action_type == "clear_subpage_rows") {
											var value = item.value;
											const pageIndex = $this.pageDetail.findIndex((page) => {
												return value.page_name == page.Name;
											});
											if (pageIndex > -1) {
												const pageData = $this.pageDetail[pageIndex]
												pageData.DefList = []
												pageData.ExtData = {}

												$this.$set(this.pageDetail, pageIndex, pageData)
											}

										} else if (item.action_type == "set_dlg_current_edit_attr") {

											if ($this.focusOldFieldId == item.value) {
												$this.setData({
													focusFieldId: ""
												})
											} else {
												$this.setData({
													focusFieldId: $this.focusOldFieldId
												})
											}
											$this.$nextTick(() => {
												$this.setData({
													focusFieldId: item.value
												})
											});
										} else if (item.action_type == "set_dlg_attr") {
											// value = {"attr":"xxx", "value":"xxx"}
											var data = item.value;
											$this.setFormValues(data)
										}
									});
								} else {

									if (result.info) {
										uni.showModal({
											title: this.translateSys(
												"error") + "4.3",
											content: result.info,
											showCancel: false,
											confirmText: this
												.translateSys('close')
										});
									}
								}

							}

						}).catch(ex => {
							// console.log(ex);
							let tip = typeof ex.errMsg == "string" ? ex.errMsg : ex
							uni.showModal({
								title: this.translateSys("error") + "4.1",
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						});
					}
				} catch (ex) {
					var tip = typeof ex == "string" ? ex : ex.message;
					uni.showModal({
						title: this.translateSys("error") + "4.2",
						content: this.translate(
								'execute_after_change_event_failed') + this
							.translateSys(
								"comma") +
							this.translate('reason') + this.translateSys("colon") +
							tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				}
			},
			operationNumber(value1, value2, operation) {
				var number1 = 0
				var number2 = 0
				if (value1)
					number1 = parseInt(value1)
				if (value2)
					number2 = parseInt(value2)
				if (!operation) {
					return value2;
				}
				if (operation == "+") {
					return number1 + number2
				} else if (operation == "-") {
					return number1 - number2
				} else if (operation == "*") {
					return number1 * number2
				} else if (operation == "/") {
					if (number2) return number1 / number2;
					else {
						throw new Error(`${this.translate("illegal_dividend")}'${value2}'`);
						return 0;
					}
				} else if (operation == "=") {
					return value2;
				} else {
					throw new Error(`${this.translate("unrecognized_operator")}'${operation}'`);
					return 0;
				}
			},

			viewActionSelectRow(value) {
				const pageData = this.pageDetail.find((page) => {
					return value.page_name == page.Name;
				});
				if (pageData?.DefList) {
					const detailStyleDefList = pageData.DefList || []
					let bFindRow = false;
					for (let index = 0; index < detailStyleDefList.length; index++) {
						const ele = detailStyleDefList[index]

						if (value.row.id) {
							if (ele.form.objId == value.row.id) {
								bFindRow = true;
							}
						} else {
							const conditions = row.condition || [];
							if (conditions.length > 0) {
								for (let index = 0; index < detailStyleDefList.length; index++) {
									const ele = detailStyleDefList[index]
									let bFindCondition = true;
									for (let i in conditions) {
										const condition = conditions[i];
										let bFind = false;
										for (let i2 in ele.form.items) {
											const ele2 = ele.form.items[i2];
											if (ele2.name != "Layout") {
												if (ele2.fieldId == condition.attr) {
													if (condition.value == ele2.value) {
														bFind = true;
													}
													break;
												}
											} else {
												const colList = ele2.setting.colList || [];
												for (let i3 in colList) {
													const col = colList[i3];
													if (col.fieldId == condition.attr) {
														if (condition.value == col.value) {
															bFind = true;
														}
														break;
													}
												}
												if (bFind) break;
											}
										}
										if (!bFind) {
											bFindCondition = false;
											break;
										}
									}
									if (bFindCondition) {
										bFindRow = true;
									}
								}
							}
						}
						if (bFindRow) {
							ele.SelBut_Checked = true;
							this.active_id = ele.form.htmlobjId;
							//自动滚动到指定元素
							uni.createSelectorQuery().select("#tabpanel" + value.page_name) //对应外层节点
								.boundingClientRect((container) => {
									uni.createSelectorQuery()
										.select("#dvpanel" + ele.form.htmlobjId) //目标节点
										.boundingClientRect((target) => {
											uni.pageScrollTo({
												scrollTop: target.top - container
													.top, //滚动到实际距离是元素距离顶部的距离减去最外层盒子的滚动距离
											});
										}).exec();
								}).exec();
						}
						break
					}
				}

			},

			viewActionRemoveRow(value) {
				if (JSON.stringify(value.row) == '{}') {
					return;
				}
				const pageIndex = this.pageDetail.findIndex((page, index2, arr) => {
					return value.page_name == page.Name;
				})
				if (pageIndex < 0)
					return
				const pageData = this.pageDetail[pageIndex]
				if (pageData?.DefList) //判断返回的action的page_name是否是待分拣//清除面板中指定id的数据
				{
					const detailStyleDefList = pageData.DefList || []
					value.row.forEach((row) => {
						if (row.id) {
							for (let index = 0; index < detailStyleDefList.length; index++) {
								const ele = detailStyleDefList[index]
								if (ele.form.objId == row.id) {
									detailStyleDefList.splice(index, 1);
									index--;
								}
							}

						} else {
							const conditions = row.condition || [];
							if (conditions.length > 0) {
								for (let index = 0; index < detailStyleDefList.length; index++) {
									const ele = detailStyleDefList[index]
									let bFindCondition = true;
									for (let i in conditions) {
										const condition = conditions[i];
										let bFind = false;
										for (let i2 in ele.form.items) {
											const ele2 = ele.form.items[i2];
											if (ele2.name != "Layout") {
												if (ele2.fieldId == condition.attr) {
													if (condition.value == ele2.value) {
														bFind = true;
													}
													break;
												}
											} else {
												const colList = ele2.setting.colList || [];
												for (let i3 in colList) {
													const col = colList[i3];
													if (col.fieldId == condition.attr) {
														if (condition.value == col.value) {
															bFind = true;
														}
														break;
													}
												}
												if (bFind) break;
											}
										}
										if (!bFind) {
											bFindCondition = false;
											break;
										}
									}
									if (bFindCondition) {
										detailStyleDefList.splice(index, 1);

									}
								}
							}

						}
					});
				}
				this.$set(this.pageDetail, pageIndex, pageData)
			},
			//更新分页签中的列表项内容
			viewActionSetRow(value) {
				const $this = this
				const pageIndex = $this.pageDetail.findIndex((page, index2, arr) => {
					return value.page_name == page.Name;
				})
				if (pageIndex < 0)
					return
				const pageData = $this.pageDetail[pageIndex]
				const detailStyleDefList = pageData.DefList || []
				detailStyleDefList.forEach(ele => {
					value.row.forEach((rowData) => {
						if (rowData.id) {
							if (ele.form.objId == rowData.id) {
								rowData.attrs.forEach(attr => {
									ele.form.items.forEach(ele2 => {
										if (ele2.name != 'Layout') {
											if (ele2.fieldId == attr.attr) {
												ele2.value = $this.operationNumber(
													ele2.value,
													attr.value,
													attr.operation
												)
											}
										} else if (ele2.name == 'Layout') {
											ele2.setting.colList.forEach(col => {
												if (col) {
													if (col.fieldId == attr.attr) {
														col.value = $this
															.operationNumber(
																col.value,
																attr.value,
																attr.operation
															)
													}
												}
											})
										}
									});
								});
							}
						} else if (rowData.condition) {
							const conditions = rowData.condition
							let bFindCondition = true;
							for (let i in conditions) {
								const condition = conditions[i];
								let bFind = false;
								for (let i2 in ele.form.items) {
									const ele2 = ele.form.items[i2];
									if (ele2.name != "Layout") {
										if (ele2.fieldId == condition.attr) {
											if (condition.value == ele2.value) {
												bFind = true;
											}
											break;
										}
									} else {
										const colList = ele2.setting.colList || [];
										for (let i3 in colList) {
											const col = colList[i3];
											if (col.fieldId == condition.attr) {
												if (condition.value == col.value) {
													bFind = true;
												}
												break;
											}
										}
										if (bFind) break;
									}
								}
								if (!bFind) {
									bFindCondition = false;
									break;
								}
							}
							if (bFindCondition) {
								rowData.attrs.forEach(attr => {
									ele.form.items.forEach(ele2 => {
										if (ele2.name != 'Layout') {
											if (ele2.fieldId == attr.attr) {
												ele2.value =
													$this.operationNumber(
														ele2.value,
														attr.value,
														attr.operation
													)
											}
										} else if (ele2.name == 'Layout') {
											ele2.setting.colList.forEach(col => {
												if (col) {
													if (col.fieldId == attr.attr) {
														col.value =
															$this.operationNumber(
																col.value, attr
																.value, attr
																.operation)
													}
												}
											})
										}
									});
								});

							}

						}
					})
				});
				pageData.DefList = detailStyleDefList
				$this.$set(this.pageDetail, pageIndex, pageData)
			},
			//加载正在码盘内容
			viewAceionRow(data) {
				// console.log(data);
				if (JSON.stringify(data.row) == '{}') {
					return;
				}
				const pageIndex = this.pageDetail.findIndex((
					page, index2, arr) => {
					return data.page_name == page.Name;
				})
				if (pageIndex < 0)
					return
				const pageData = this.pageDetail[pageIndex]
				var styleStr = JSON.stringify(pageData.StyleDef);

				var detailStyle = JSON.parse(styleStr);
				if (detailStyle.form) {
					data.row.forEach(row => {
						detailStyle = JSON.parse(styleStr);
						detailStyle.form.objId = row.id;
						detailStyle.form.htmlobjId = row.id ? row.id.replace(/-/g, '').replace('{', '')
							.replace(
								'}', '') : 'null';
						detailStyle.form.attrs = row.attrs;
						row.attrs.forEach(attr => {
							detailStyle.form.items.forEach(ele => {
								if (ele.name != 'Layout') {
									if (ele.fieldId == attr.attr)
										ele.value = attr.value;
								} else if (ele.name == 'Layout') {
									ele.setting.colList.forEach(col => {
										if (col) {
											if (col.fieldId == attr.attr)
												col.value = attr.value;
										}
									});
								}
							});
						});

						pageData.DefList.push(detailStyle);
						this.$set(this.pageDetail, pageIndex, pageData)

					});
				}
			},
			//加载已码盘内容
			viewAceionContent(data) {
				var $this = this;
				const pageIndex = $this.pageDetail.findIndex((
					page, index2, arr) => {
					return data.page_name == page.Name;
				})
				if (pageIndex < 0)
					return
				const pageData = $this.pageDetail[pageIndex]

				pageData.ExtData = data.ext_data || {}

				if (JSON.stringify(data.content) == '{}') {
					return;
				}
				var styleStr = JSON.stringify(pageData.StyleDef);
				var detailStyle = JSON.parse(styleStr);
				if (detailStyle.form) {
					data.content.forEach(cont => {
						detailStyle = JSON.parse(styleStr);
						detailStyle.SelBut_Checked = data.checkbox ?? true;

						detailStyle.form.objId = cont.id;
						detailStyle.form.htmlobjId = cont.id ? cont.id.replace(/-/g,
								'')
							.replace('{', '').replace('}',
								'') : 'null';
						detailStyle.form.attrs = cont.attrs;
						cont.attrs.forEach(attr => {
							detailStyle.form.items.forEach(ele => {
								if (ele.name != 'Layout') {
									if (ele.fieldId == attr.attr)
										ele.value = attr.value;
								} else if (ele.name == 'Layout') {
									ele.setting.colList.forEach(
										col => {
											if (col) {
												if (col.fieldId ==
													attr.attr)
													col.value = attr.value;
											}
										});
								}
							});
						});
						//如果 clear = false 则不需要清除，根据id判断是否存在，不存在插入到页面，如果存在用新的属性覆盖
						if (data.clear == false) {
							var isflag = true;
							pageData.DefList.forEach((style, index) => {
								if (style.form.objId == detailStyle.form.objId) {
									cont.attrs.forEach(attr => {
										style.form.items.forEach(ele => {
											if (ele.name != 'Layout') {
												if (ele.fieldId == attr.attr)
													ele.value = attr.value;
											} else if (ele.name == 'Layout') {
												ele.setting.colList.forEach(
													col => {
														if (col) {
															if (col.fieldId ==
																attr
																.attr)
																col.value =
																attr.value;
														}
													});
											}
										});
									});
									isflag = false;
								}
							});
							if (isflag) pageData.DefList.push(detailStyle); //待分拣
						} else {
							pageData.DefList.push(detailStyle); //待分拣
						}
						// $this.setData({pageDetail:pageD})
						$this.$set(this.pageDetail, pageIndex, pageData)

					});
				}
				$this.$set(this.pageDetail, pageIndex, pageData)
			},
			setFormValues(attrs) {
				const head_styledef = this.head_styledef
				if (JSON.stringify(attrs) == '{}') {
					return;
				}
				console.log(attrs)
				attrs.forEach(async (attr, key) => {
					if (attr.choice_list) {
						var dictItemList = [];
						attr.choice_list.forEach(async (val, index) => {
							dictItemList.push({
								text: val,
								value: val
							});
						});

						head_styledef.form.items.forEach(async (attr_item, index) => {
							if (attr_item.name != "Layout") {
								if (attr_item.fieldId == attr.attr) {
									if (attr_item.useDict) {
										attr_item.dict = dictItemList;
									} else {
										attr_item.selections = dictItemList;
									}
								}
							} else if (attr_item.name == "Layout") {
								attr_item.setting.colList.forEach((col) => {
									if (col) {
										if (col.fieldId == attr.attr) {
											if (col.useDict) {
												col.dict = dictItemList;
											} else {
												col.selections = dictItemList;
											}
										}
									}
								});
							}
						});
					}
					if (!head_styledef.form.model[attr.attr]) {
						head_styledef.form.model[attr.attr] = attr.value;
					}
					head_styledef.form.items.forEach(async (ele) => {
						if (ele.name != "Layout") {
							if (ele.fieldId == attr.attr) {
								ele.value = attr.value;
								ele.oldvalue = attr.value;
								if (ele.name == "Input") {
									if (attr.prompt) ele.placeholder = attr.prompt;
								}
								if (attr.enable !== undefined) {
									if (attr.enable) ele.disabled = false;
									else ele.disabled = true;
								}
							}
						} else if (ele.name == "Layout") {
							ele.setting.colList.forEach((col) => {
								if (col) {
									if (col.fieldId == attr.attr) {
										col.value = attr.value;
										col.oldvalue = attr.value;
										if (col.name == "Input") {
											if (attr.prompt) col.placeholder = attr.prompt;
										}
										if (attr.enable !== undefined) {
											if (attr.enable) col.disabled = false;
											else col.disabled = true;
										}
									}
								}
							});
						}

					})
					//判断表单里是否有返回字段，没有就装载到model里，点击确定提交的时候带上这些数据
				})
				console.log(head_styledef)
				this.setData({
					head_styledef: head_styledef
				})
			},
			onClickItem(e) { //选择页签
				// console.log(e);
				this.current = e.currentIndex
			},
			onDetail1EnterChange(item) { //码盘中样式回车事件
				console.log(item);
			},
			async del(pageData, style, event) {
				//获取表头属性
				var head_attr = {};
				this.head_styledef.form.items.forEach(item => {
					if (item.name == "Layout") { //判断是否是栅栏格式
						item.setting.colList.forEach(col => {
							if (col != null) head_attr[col.fieldId] =
								col.value;
						});
					} else
						head_attr[item.fieldId] = item.value;
				});
				// console.log(head_attr);
				//获取正在分拣属性
				var detailAttrList = [];
				var detail_attr = {};
				style.form.items.forEach(item => {
					if (item.name == "Layout") { //判断是否是栅栏格式
						item.setting.colList.forEach(col => {
							if (col != null) detail_attr[col
									.fieldId] = col
								.value;
						});
					} else
						detail_attr[item.fieldId] = item.value;
				});

				detail_attr['id'] = style.form.objId;
				if (pageData.Select_Button == true) { //判断选择按钮是否为true
					if (style.SelBut_Checked == true)
						detailAttrList.push(detail_attr);
				} else
					detailAttrList.push(detail_attr);

				// console.log(detailAttrList);
				//获取正在分拣里没有显示的字段
				style.form.attrs.forEach(attr => {
					for (var key in detailAttrList) {
						if (style.form.objId == detailAttrList[key]['id']) {
							var keys = Object.keys(detailAttrList[key]);
							var isflag = true;
							keys.forEach((ele) => {
								if (ele == attr.attr) isflag = false;
							});
							if (isflag) {
								detailAttrList[attr.attr] = attr.value;
							}
						}
					}
				});
				var input_param = Base64.encode(
					JSON.stringify(
						Object.keys(head_attr).map((a) => ({
							attr: a,
							value: head_attr[a] || "",
						}))
					)
				);
				var jsonlist = [];
				detailAttrList.forEach(attr => {
					jsonlist.push({
						id: attr["id"] || "",
						attrs: Object.keys(attr).map((a) => ({
							attr: a,
							value: attr[a] || "",
						})).filter((a) => {
							return a.attr != "id"
						})
					});
				});
				if (jsonlist.length == 0) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate("tip_no_select_data"),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				// console.log(jsonlist);
				const list = []
				list.push({
					page_name: pageData.Name,
					item_list: jsonlist,
					ext_data: pageData.ExtData
				})
				$this.runCustomEvent(pageData, event, input_param, list);
			},

			popupChange(e) {
				console.log('当前模式：' + e.type + ',状态：' + e.show);
			},
			checkChange(e) { //弹框check选择
				// console.log(e.target.dataset);
				var index = e.target.dataset.index;
				var ischeck = e.target.dataset.ischeck;
				var data = this.check_list.items;
				// this.check_list.items=[];
				if (this.check_list.multiple_choice == "0") { //判断时单选还是多选
					for (var i in data) {
						data[i].check = false;
					}
				}
				data[index].check = ischeck ? false : true;
				this.check_list.items = data;

			},
			popup_cancel(e) { //弹框取消
				this.$refs.popup.close();
			},
			popup_sava(e) { //弹框确定
				var $this = this;
				var items = $this.check_list.items;
				var data = [];
				var name = "";
				for (var i = 0; i < items.length; i++) {
					if (items[i].check == true) {
						if (name)
							name += ';';
						name += items[i].name;
						data.push({
							id: items[i].id,
							name: items[i].name
						});
					}
				}
				if (!$this.popupParam) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: "popupParam为空！",
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				if (data.length == 0) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate("tip_no_select_data"),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				var callback_eventid = $this.popupParam.button_callback.trim();
				var info = {
					eventid: callback_eventid,
					edtype: "0",
					projectid: '',
					rclsid: '',
					robjid: '',
					userlogin: '',
					clsid: $this.ClsID,
					objid: "",
					attr: $this.popupParam.req,
					dataJson: data
				}
				$this.DataObjRunCustomEvent(info, $this.popupParam.data_attr);
				this.$refs.popup.close();
			},

			async DataObjRunCustomEvent(info, data_attr) {
				var $this = this;
				var enviroment = {
					'function': '3000', // 功能点编号
					cls_id: this.ClsID, // 功能点主数据类标识
					'button': 'top', // top/bottom
					button_name: this.translateSys('add2'),
					master: {
						cls_id: this.ClsID, // button=bottom时 master的cls_id
						//obj_id: ''  // button=bottom时 master的obj_id
					}
				};
				if (data_attr) {
					enviroment.edit_dlg = {
						type: 'small', //小窗口
						class_id: this.ClsID, //当前数据类id
					}
					if (data_attr) {
						enviroment.edit_dlg.form_control = { //所属的表单控件
							name: data_attr.Name, //字段属性
							text: data_attr.DispName, //显示文本
							group_name: data_attr.GroupName, //属性组
							type: data_attr.Type, //字段类型
							readonly: data_attr.ReadOnly, //是否只读
							button_img: data_attr.button_img, //引用按钮的图标
							button_tooltip: data_attr.button_tooltip //引用按钮的tooltip
						}
					}
				}
				enviroment = Base64.encode(JSON.stringify(enviroment)); //将字符串转换为base64编码
				var input_param = Base64.encode(JSON.stringify(info.attr)); //将字符串转换为base64编码
				var global_attr = Base64.encode(JSON.stringify(this.global_attr)); //将字符串转换为base64编码
				if (info.dataJson)
					info.dataJson = Base64.encode(JSON.stringify(info.dataJson)); //将字符串转换为base64编码
				var obj_attr = {};
				info.attr.forEach(item => {
					obj_attr[item.attr] = item.value;
				});
				if (!info.eventid.includes('{')) info.eventid = '{' + info.eventid + '}';
				var dataInfo = {
					ed_type: info.edtype,
					start_transaction: true,
					class_id: info.clsid,
					class_name: '',
					event_id: info.eventid,
					event_name: '',
					data_obj_id: info.objid,
					obj_attr: obj_attr,
					prj_id: info.projectid,
					ref_cls_id: info.rclsid,
					rel_obj_id: info.robjid,
					user_login: info.userlogin,
					data_json: info.dataJson,
					compose_info: '',
					ext_info: enviroment,
					global_attr: global_attr,
					input_param: input_param,
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data
							.err_info :
							data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						} else uni.showModal({
							title: this.translateSys("tip"),
							content: tip + ',' + this.translateSys('tip') + ':' + data
								.ret,
							showCancel: false,
							confirmText: this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data
							.info
							.join(
								'<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys('close')
						});

						var actionlist = data.action;
						if (actionlist) {
							console.log(actionlist);
							for (var i = 0; i < actionlist.length; i++) {
								var action = actionlist[i];
								if (action.action_type == 'set_dlg_attr') {
									var result = action.value;
									$this.setFormValues(result)
								} else if (action.action_type == 'set_dlg_attr_show') {
									var result = action.value;
									result.forEach(async (attr, key) => {
										$this.head_styledef.form.items.forEach(async (
											ele,
											index) => {
											//判断是否是栅格表单
											if (ele.name != 'Layout') {
												if (ele.fieldId == attr
													.attr) {
													ele.show = attr.show;
												}
											} else if (ele.name ==
												'Layout') {
												ele.setting.colList
													.forEach((col) => {
														if (col) {
															if (col
																.fieldId ==
																attr
																.attr
															) {
																col.show =
																	attr
																	.show;
															}
														}
													});
											}
										});
									});
									var head_styledef = JSON.parse(JSON.stringify($this.$data
										.head_styledef));
									$this.head_styledef = [];
									$this.head_styledef = head_styledef;
									// console.log($this.head_styledef);
								} else if (action.action_type == 'set_global_attr') {
									$this.global_attr = action.value || [];
								} else {
									uni.showModal({
										title: this.translateSys("tip"),
										content: this.translateSys(
												"quotation_mark_left") +
											action
											.action_type + this.translateSys(
												"quotation_mark_right") + this
											.translate(
												"tip_action_unprocessed"),
										showCancel: false,
										confirmText: this.translateSys('close')
									});
								}
							}
						}
						console.log($this.head_styledef);
						if (data.result) {
							var result = data.result;
							$this.setFormValues(result)
						}
					}

				}).catch(ex => {
					// console.log(ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: this.translateSys("error") + "3.1",
						content: exStr,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				});
			},
			dataObjRunCustomEvent_Return(eventid, data_attr, button_callback, item) {
				console.log("dataObjRunCustomEvent_Return", eventid, data_attr, button_callback)
				const $this = this
				var enviroment = {
					'function': '3000', // 功能点编号
					cls_id: $this.ClsID, // 功能点主数据类标识
					'button': 'top', // top/bottom
					button_name: $this.translateSys('add2'),
					master: {
						cls_id: $this.ClsID, // button=bottom时 master的cls_id
						//obj_id: ''  // button=bottom时 master的obj_id
					}
				};
				var obj_attr = $this.head_styledef.form.model;
				console.log(obj_attr);
				var req = Object.keys(obj_attr).map((a) => ({
					attr: a,
					value: obj_attr[a] || "",
				}));

				var extinfo = enviroment;
				extinfo.edit_dlg = {
					type: 'small', //小窗口
					class_id: $this.ClsID, //当前数据类id
				}
				extinfo = Base64.encode(JSON.stringify(extinfo)); //将字符串转换为base64编码
				var global_attr = Base64.encode(JSON.stringify($this.global_attr)); //将字符串转换为base64编码
				var obj_attr = {};
				req.forEach(item2 => {
					obj_attr[item2.attr] = item2.value;
				});
				let input_param = Base64.encode(
					JSON.stringify(
						Object.keys(obj_attr).map((a) => ({
							attr: a,
							value: obj_attr[a] || "",
						}))
					)
				);

				if (!eventid.includes('{')) eventid = '{' + eventid + '}';
				var dataInfo = {
					ed_type: "0",
					start_transaction: true,
					class_id: $this.ClsID,
					class_name: '',
					event_id: eventid,
					event_name: '',
					data_obj_id: '',
					obj_attr: obj_attr,
					prj_id: '',
					ref_cls_id: '',
					rel_obj_id: '',
					user_login: '',
					data_json: [],
					compose_info: '',
					ext_info: extinfo,
					global_attr: global_attr,
					input_param: input_param,
				};
				console.log(dataInfo);
				// return;
				runCustomEvent(dataInfo).then(data => {
					if (data.ret != 0) {
						var tip = data.err_info ? typeof data.err_info == 'string' ? data
							.err_info :
							data
							.err_info.join('<br/>') : '';
						if (data.ret == 801) {
							if ($this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos + 1);
							}
							uni.showModal({
								title: $this.translateSys("tip"),
								content: tip,
								showCancel: false,
								confirmText: $this.translateSys('close')
							});
						} else uni.showModal({
							title: $this.translateSys("tip"),
							content: tip + ',' + $this.translateSys('tip') + ':' + data
								.ret,
							showCancel: false,
							confirmText: $this.translateSys('close')
						});
						return false
					} else {
						var tip = data.info ? typeof data.info == 'string' ? data.info : data
							.info
							.join(
								'<br/>') : '';
						if (tip) uni.showModal({
							title: $this.translateSys("tip"),
							content: tip,
							showCancel: false,
							confirmText: $this.translateSys('close')
						});

						if (data != "") {
							var actions = data.action;
							if (actions) {
								for (var i = 0; i < actions.length; i++) {
									var action = actions[i];
									console.log(action)
									var val = action.value;
									var enviroment = JSON.stringify(enviroment);

									if (action.action_type == 'open_panel') {
										var d = dialog({
											title: '<i class="ace-icon fa fa-info-circle"></i> ' +
												$this.translateSys("tip"),
											content: $this.translateSys(
													"quotation_mark_left") +
												action
												.action_type + $this.translateSys(
													"quotation_mark_right") + $this
												.translate(
													"tip_action_unprocessed")
										});
										d.show();
									} else if (action.action_type == 'open_select_userdlg') {
										var style = val.style;
										// style == 'user' ? '选择人员' : style == 'department' ? '选择部门' : style == 'role' ? '选择角色' : ''
										var param = {
											item: item,
											button_callback: button_callback,
											req: req,
											data_attr: data_attr
										}
										uni.navigateTo({
											url: '../selpsn/index?mulit=false&param=' +
												JSON
												.stringify(
													param),
											events: {
												AddPer(data, param) {
													// console.log(param);
													console.log(data);
													var callback_eventid = param
														.button_callback
														.trim();
													var info = {
														eventid: callback_eventid,
														edtype: "0",
														projectid: '',
														rclsid: '',
														robjid: '',
														userlogin: '',
														clsid: $this.param
															.DataCls
															.id,
														objid: "",
														attr: param.req,
														inputparameter: data,
														dataJson: [],
													}
													$this.DataObjRunCustomEvent(info,
														param
														.data_attr);
												}
											}
										});
									} else if (action.action_type == 'open_data_query_dlg') {
										var d = dialog({
											title: '<i class="ace-icon fa fa-info-circle"></i> ' +
												$this.translateSys("tip"),
											content: $this.translateSys(
													"quotation_mark_left") +
												action
												.action_type + $this.translateSys(
													"quotation_mark_right") + $this
												.translate(
													"tip_action_unprocessed")
										});
										d.show();
									} else if (action.action_type == 'open_common_dlg') {

										if (val.common_dlg_id == 'check_list') {
											$this.setData({
												check_list: val.config
											})
											console.log($this.check_list)
											if (val.config.appear_style == 'sideslip') //判断是否是侧滑
												$this.setData({
													popupType: "right"
												})
											else
												$this.setData({
													popupType: "center"
												})
											// open 方法传入参数 等同在 uni-popup 组件上绑定 type属性
											$this.$refs.popup.open($this.popupType);
											var popupParam = {
												item: item,
												button_callback: button_callback,
												req: req,
												data_attr: data_attr
											}
											$this.setData({
												popupParam: popupParam
											})
										}
									} else if (action.action_type == 'open_project_query_dlg') {
										//console.log(action.value.select_range);
										//console.log(action.value.mulit_select);
										var priRel = '-1';
										if (action.value.select_range == '全部相关')
											priRel = '0';
										else if (action.value.select_range == '我负责的项目')
											priRel = '1';
										else if (action.value.select_range == '我创建的')
											priRel = '2';
										else if (action.value.select_range == '我参与的' || action
											.value
											.select_range == '我参加的')
											priRel = '3';
										else if (action.value.select_range == '我关注的')
											priRel = '4';
										else if (action.value.select_range == '我下属的项目')
											priRel = '5';
										var param_ = {
											item: item,
											button_callback: button_callback,
											req: req
										}
										uni.navigateTo({
											url: '../selPrj/index?relation=' + priRel +
												'&param=' +
												JSON.stringify(param_),
											events: {
												AddPer(data, param) {
													var attr = param.item.fieldId;
													$this.head_styledef.form.model[
															attr] =
														data[0].ID +
														';' + data[0].Name;

													// $this.classAttrList[param.index].Attr[param.iindex].Value=data[0].Name;
													// $this.classAttrList[param.index].Attr[param.iindex].ValID=data[0].ID+';'+data[0].Name;
													var callback_eventid = param
														.button_callback
														.trim();
													if (callback_eventid) {
														var info = {
															eventid: callback_eventid,
															edtype: "2",
															projectid: data[0].ID,
															rclsid: "",
															robjid: "",
															userlogin: "",
															clsid: $this.$data
																.param
																.DataCls.id,
															objid: "",
															attr: param.req,
															dataJson: [],
														}

														$this.DataObjRunCustomEvent(
															info);
													}
												}
											}
										});
									} else {
										uni.showModal({
											title: $this.translateSys("tip"),
											content: $this.translateSys(
													"quotation_mark_left") +
												action.action_type + $this.translateSys(
													"quotation_mark_right") + $this
												.translate(
													"tip_action_unprocessed"),
											showCancel: false,
											confirmText: $this.translateSys('close')
										});
									}
								}
							}
						} else {
							uni.showModal({
								title: $this.translateSys('tip') + "5.2",
								content: $this.translateSys("quotation_mark_left") +
									"before_click_button" + $this.translateSys(
										"quotation_mark_right") + $this.translateSys(
										"comma") + 'event_id' + eventid,
								showCancel: false,
								confirmText: $this.translateSys('close')
							});
						}
					}

				}).catch(ex => {
					// console.log(ex);
					let exStr = JSON.stringify(ex)
					if (exStr == "{}")
						exStr = ex
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : exStr
					uni.showModal({
						title: $this.translateSys('tip') + "5.1",
						content: exStr,
						showCancel: false,
						confirmText: $this.translateSys('close')
					});
				});
			},


			onPanelClick(value, id) {
				// console.log(value);
				this.active_id = id;
			},
			//点击按钮列表
			clickDropdownBtns(pageData) {
				const that = this
				const itemlist = [];
				const btnList = pageData.DropDownButton || []

				for (let i in btnList) {
					itemlist.push(btnList[i].ShowName || "");
				}
				uni.showActionSheet({
					// title: '按钮列表',
					itemList: itemlist,
					success: (e) => {
						console.log(e.tapIndex);
						var btn = btnList[e.tapIndex];
						that.onBtnClick(btn, pageData);
					}
				})
			},
			onBtnClick(btn, pageData) {
				const $this = this
				if (btn.Prompt) {
					const sContent = btn.PromptContent || this.translate("confirm")

					uni.showModal({
						title: this.translateSys("tip"),
						content: btn.PromptContent || this.translate("confirm"),
						cancelText: this.translateSys('ok'),
						confirmText: this.translateSys('cancel'),
						success: function(res) {
							if (res.cancel) {
								$this.onButtonClicked(btn, pageData, -1);
							}

						},
					})

				} else {
					this.handleButtonClick((done) => {
						this.onButtonClicked(btn, pageData, -1);
						setTimeout(() => {
							done(); // 重置状态
						}, 1000);
					});

				}
			},
			onRowBtnClick(btn, pageData, index) {
				const $this = this
				if (btn.Prompt) {
					const sContent = btn.PromptContent || this.translate("confirm")
					uni.showModal({
						title: this.translateSys("tip"),
						content: btn.PromptContent || this.translate("confirm"),
						cancelText: this.translateSys('ok'),
						confirmText: this.translateSys('cancel'),
						success: function(res) {
							if (res.cancel) {
								$this.onButtonClicked(btn, pageData, index);
							}

						},
					})

				} else {
					this.handleButtonClick((done) => {
						this.onButtonClicked(btn, pageData, index);
						setTimeout(() => {
							done(); // 重置状态
						}, 1000);
					});

				}
			},
			onButtonClicked(btn, pageData, index) {
				this.After_OK_Event = {}
				let enviroment = {
					button: "top",
					button_name: btn.ShowName,
					cls_id: btn.Cls_ID,
					function: "5601",
					master: {},
				};
				if (btn.FunCode == "TriggerEvent") {
					this.After_OK_Event = btn?.After_Event || {};
					this.sava(pageData, btn.Event);
				} else if (btn.FunCode == "Cancel") {
					this.cancel();
				} else if (btn.FunCode == "Delete") {
					if (index > -1) {
						const pageIndex = this.pageDetail.findIndex((
							page) => {
							return pageData.Name == page.Name;
						})
						const style = pageData.DefList[index];
						//删除码盘中样式面板
						pageData.DefList.splice(index, 1);
						if (btn.AfterProcess_Event.ID)
							this.del(pageData, style, btn.AfterProcess_Event);
						this.$set(this.pageDetail, pageIndex, pageData)
					}
				} else if (btn.FunCode == "Modify") {
					if (index > -1) {
						const style = pageData.DefList[index];
						if (btn.Edit_dlg.Model == "small") {
							this.showSmallDialog(btn, style, enviroment, pageData);
						} else if (btn.Edit_dlg.Model == "form") {
							this.showFormDialog(btn, style, enviroment, pageData);
						} else {
							uni.showModal({
								title: this.translateSys("tip"),
								content: this.translateSys("unrealized"),
								showCancel: false,
								confirmText: this.translateSys('close')
							});
						}
					}

				} else {
					this.$Message.warning(this.$t("sys.unrealized"));
				}
			},
			//修改小窗口数据
			showSmallDialog(btn, row, enviroment, pageData) {
				var data = {
					Add_BtnName: btn.ShowName,
					EditDlgMode: btn.Edit_dlg.Model,
					clsid: btn.Cls_ID,
					objid: "",
					cls_name: btn.Cls_Name,
					Edit_dlg: btn.Edit_dlg
				};
				const objAttr = {}
				row.form.items.forEach(item => {
					if (item.name == "Layout") { //判断是否是栅栏格式
						item.setting.colList.forEach(col => {
							if (col != null) objAttr[col
								.fieldId] = col.value;
						});
					} else
						objAttr[item.fieldId] = item.value;
				});
				const url = `../modal/3018?param=${JSON.stringify(data)}&titlename=${btn.Edit_dlg
					.Name}&editMode=1&objAttr=${JSON.stringify(objAttr)}&type=updateDataObj`

				var $this = this;
				uni.navigateTo({
					url: url,
					events: {
						// 为指定事件添加一个监听器，获取被打开页面传送到当前页面的数据
						updateDataObj: function(formData) {
							const pageIndex = $this.pageDetail.findIndex((
								page) => {
								return pageData.Name == page.Name;
							})
							if (pageIndex < 0)
								return
							Object.assign(row.form.model, formData);
							row.form.items.forEach(async (ele, index) => {
								if (ele.name != "Layout") {
									let value = formData[ele.fieldId]
									if (value)
										ele.value = value

								} else {
									ele.setting.colList.forEach(async (col) => {
										if (col) {
											let value = formData[col
												.fieldId]
											if (value)
												col.value = value
										}
									});
								}
							})
							$this.$set($this.pageDetail, pageIndex, pageData)
						},

					}
				});
			},

			//修改自定义表单数据
			showFormDialog(btn, row, enviroment, pageData) {
				const objAttr = {}
				row.form.items.forEach(item => {
					if (item.name == "Layout") { //判断是否是栅栏格式
						item.setting.colList.forEach(col => {
							if (col != null) objAttr[col.fieldId] = col.value;
						});
					} else
						objAttr[item.fieldId] = item.value;
				});

				const url =
					`../modal/form/index?param=${JSON.stringify(btn)}&titlename=${btn.ShowName}&editMode=1&objAttr=${JSON.stringify(objAttr)}&type=updateDataObj`
				var $this = this;
				uni.navigateTo({
					url: url,
					events: {
						// 为指定事件添加一个监听器，获取被打开页面传送到当前页面的数据
						updateDataObj: function(formData) {
							const pageIndex = $this.pageDetail.findIndex((
								page) => {
								return pageData.Name == page.Name;
							})
							if (pageIndex < 0)
								return
							Object.assign(row.form.model, formData);
							row.form.items.forEach(async (ele) => {
								if (ele.name != "Layout") {
									let value = formData[ele.fieldId]
									if (value)
										ele.value = value

								} else {
									ele.setting.colList.forEach(async (col) => {
										if (col) {
											let value = formData[col
												.fieldId]
											if (value)
												col.value = value
										}
									});
								}
							})
							$this.$set($this.pageDetail, pageIndex, pageData)
							console.log($this.pageDetail)

						},
					}
				});
			},
			//确定
			ok(pageData) {
				this.Before_OK_Event = pageData.Before_ok;
				this.After_OK_Event = pageData.After_ok;
				// console.log(this.Before_OK_Event);
				// console.log(this.After_OK_Event);
				if (this.Before_OK_Event.ID) //是否有确定前事件
					this.sava(pageData, this.Before_OK_Event);
				else if (this.After_OK_Event.ID) //是否有确定后事件
					this.sava(pageData, this.After_OK_Event);
			},
			sava(pageData, event) {
				var $this = this;
				// if (pageData.DefList.length == 0) {
				// 	uni.showModal({
				// 		title: this.translateSys("tip"),
				// 		content: this.translate(
				// 				"tip_no_data_first") +
				// 			this.translateSys(
				// 				"quotation_mark_left") + pageData.Name + this
				// 			.translateSys(
				// 				"quotation_mark_right") +
				// 			this.translate(
				// 				"tip_no_data_last"),
				// 		showCancel: false,
				// 		confirmText: this.translateSys('close')
				// 	});
				// 	return false;
				// }
				//获取表头属性
				var head_attr = {};
				this.head_styledef.form.items.forEach(item => {
					if (item.name == "Layout") { //判断是否是栅栏格式
						item.setting.colList.forEach(col => {
							if (col != null) head_attr[col.fieldId] =
								col.value;
						});
					} else
						head_attr[item.fieldId] = item.value;
				});
				// console.log(head_attr);
				//获取正在码盘属性
				var detailAttrList = [];
				pageData.DefList.forEach(style => {
					var detail_attr = {};
					style.form.items.forEach(item => {
						if (item.name == "Layout") { //判断是否是栅栏格式
							item.setting.colList.forEach(col => {
								if (col != null)
									detail_attr[col.fieldId] = col.value;
							});
						} else
							detail_attr[item.fieldId] = item.value;
					});

					detail_attr['id'] = style.form.objId;
					if (pageData.Select_Button ==
						true) { //判断选择按钮是否为true
						if (style.SelBut_Checked == true)
							detailAttrList.push(detail_attr);
					} else
						detailAttrList.push(detail_attr);
				});
				// console.log(detailAttrList);
				//获取正在码盘里没有显示的字段
				pageData.DefList.forEach(style => {
					style.form.attrs.forEach(attr => {
						for (var key in detailAttrList) {
							if (style.form.objId == detailAttrList[key]
								[
									'id'
								]) {
								var keys = Object.keys(detailAttrList[
									key]);
								var isflag = true;
								keys.forEach((ele) => {
									if (ele == attr.attr)
										isflag =
										false;
								});
								if (isflag) {
									detailAttrList[attr.attr] = attr
										.value;
								}
							}
						}
					});
				});
				// console.log(detailAttrList);
				//    return;
				var input_param = Base64.encode(
					JSON.stringify(
						Object.keys(head_attr).map((a) => ({
							attr: a,
							value: head_attr[a] || "",
						}))
					)
				);
				var jsonlist = [];
				detailAttrList.forEach(attr => {
					jsonlist.push({
						id: attr["id"] || "",
						attrs: Object.keys(attr).map((a) => ({
							attr: a,
							value: attr[a] || "",
						}))
					});
				});
				if (jsonlist.length == 0) {
					uni.showModal({
						title: this.translateSys("tip"),
						content: this.translate("tip_no_select_data"),
						showCancel: false,
						confirmText: this.translateSys('close')
					});
					return;
				}
				const list = []
				list.push({
					page_name: pageData.Name,
					item_list: jsonlist,
					ext_data: pageData.ExtData
				})
				// console.log(jsonlist);
				$this.runCustomEvent(pageData, event, input_param, list);
				// jsonlist.forEach(async (json,key)=>{
				// 	await $this.runCustomEvent(event,input_param,json,'1');
				// });
			},
			//执行确定脚本
			async runCustomEvent(pageParam, event, input_param, json, type) {
				var $this = this;
				var data_json = Base64.encode(
					JSON.stringify(json)
				);
				var dataInfo = {
					ed_type: 0,
					start_transaction: true,
					class_id: this.ClsID,
					class_name: '',
					event_id: event.ID,
					event_name: '',
					data_obj_id: '',
					obj_attr: '',
					prj_id: '',
					ref_cls_id: '',
					rel_obj_id: '',
					user_login: '',
					data_json: data_json,
					compose_info: '',
					ext_info: '',
					global_attr: '',
					input_param: input_param,
				};
				runCustomEvent(dataInfo).then(result => {
					console.log(result);
					if (result.ret != 0) {
						var tip = result.err_info ? typeof result
							.err_info == 'string' ? result.err_info :
							result.err_info.join('<br/>') : '';
						if (result.ret == 801) {
							if (this.param.Only_Script_Error) {
								let pos = tip.indexOf("：");
								if (pos > -1) tip = tip.substring(pos +
									1);
							}
							uni.showModal({
								title: this.translateSys(
									"tip"),
								content: tip,
								showCancel: false,
								confirmText: this.translateSys(
									'close')
							});
						} else uni.showModal({
							title: this.translateSys('tip'),
							content: tip + ',' + this
								.translateSys('tip') + ':' +
								result.ret,
							showCancel: false,
							confirmText: this.translateSys(
								'close')
						});
						return false;
					} else {
						var tip = result.info ? typeof result.info ==
							'string' ? result.info : result.info
							.join('<br/>') : '';
						if (tip) uni.showModal({
							title: this.translateSys('tip'),
							content: tip,
							showCancel: false,
							confirmText: this.translateSys(
								'close')
						});
						if (result.result_type == 0) {
							if (result.action) {
								//	uni.showModal({title:this.translateSys("tip"),content:JSON.stringify(result.action),showCancel:false,confirmText:this.translateSys("cancel")});

								result.action.forEach(item => {
									if (item.action_type ==
										"insert_subtable_page_row") { //码盘中
										var value = item.value;
										//加载已经码盘数据
										$this.viewAceionRow(value);
										//清空条码内容
										$this.head_styledef.form.items.forEach((item,
											index) => {
											if (item.fieldId !=
												"S_CNTR_CODE") {
												item.value = '';
												item.oldvalue = '';
												$this.head_styledef.form.model[
													item
													.fieldId] = '';
											}
										});

										uni.showModal({
											title: $this.translateSys("tip"),
											content: $this.translate(
												'execute_event_success'),
											showCancel: false,
											confirmText: $this.translateSys(
												'close')
										});
									} else if (item.action_type ==
										"set_subtable_page_content"
									) { //已码盘
										$this.param.Show_Welcom_Page = false;
										var value = item.value;
										const pageData = $this.pageDetail.find((
											page) => {
											return value.page_name == page
												.Name;
										});
										if (value.clear_confirm != false && value
											.clear == true &&
											pageData && pageData.DefList.length > 0
										) { //判断是否清空页签内容,正在码盘是否有数据
											uni.showModal({
												title: $this.translateSys(
													'tip'),
												content: $this.translate(
														"are_you_sure_clear_first"
													) +
													$this.translateSys(
														"quotation_mark_left"
													) +
													value.page_name +
													$this.translateSys(
														"quotation_mark_right"
													) +
													$this.translate(
														"are_you_sure_clear_last"
													),
												cancelText: $this.translateSys(
													'ok'),
												confirmText: $this
													.translateSys('cancel'),
												success: function(res) {
													if (res.cancel) {
														if (pageData)
															pageData
															.DefList = [];
														$this
															.viewAceionContent(
																value);
													} else if (res
														.confirm) {
														if (pageData)
															pageData
															.DefList = [];
														$this
															.viewAceionContent(
																value);
													}
												}
											});
										} else {
											if (pageData)
												pageData.DefList = [];
											$this.viewAceionContent(value);
										}
									} else if (item.action_type ==
										"select_subtable_page") {
										var value = item.value;
										const pageIndex = $this.pageDetail.findIndex((
											page) => {
											return value.page_name == page
												.Name;
										});
										if (pageIndex > -1) {
											$this.setData({
												current: pageIndex
											})
										}
									} else if (item.action_type ==
										"remove_subtable_page_row") { //清除面板中指定id的数据
										let value = item.value;
										$this.viewActionRemoveRow(value)
									} else if (item.action_type ==
										"set_subtable_page_row") {
										$this.viewActionSetRow(item.value)
									} else if (item.action_type ==
										"set_subtable_page_ext_data") {
										let value = item.value;
										const pageData = $this.pageDetail.find((
											page) => {
											return value.page_name == page
												.Name;
										});
										if (pageData) {
											pageData.ExtData = value.ext_data
										}

									} else if (item.action_type ==
										"clear_subpage_rows") {
										var value = item.value;
										const pageIndex = $this.pageDetail.findIndex((
											page) => {
											return value.page_name == page
												.Name;
										});
										if (pageIndex > -1) {
											const pageData = $this.pageDetail[
												pageIndex]
											pageData.DefList = []
											pageData.ExtData = {}

											$this.$set(this.pageDetail, pageIndex,
												pageData)
										}
									} else if (item.action_type ==
										"set_dlg_current_edit_attr") {
										if ($this.focusOldFieldId == item.value)
											$this.setData({
												focusFieldId: ""
											})
										else {
											$this.setData({
												focusFieldId: $this
													.focusOldFieldId
											})
										}
										$this.$nextTick(() => {
											$this.setData({
												focusFieldId: item
													.value
											})
										});
									} else if (item.action_type ==
										"set_dlg_attr") {
										// value = {"attr":"xxx", "value":"xxx"}
										var data = item.value;
										$this.setFormValues(data)
									}

								});
							} else {
								if ($this.After_OK_Event.ID != event.ID) { //判断当前事件是否是确定后事件
									$this.sava(pageParam, $this.After_OK_Event); //执行确定后事件

								}
							}
						} else {

							if (result.info) {
								uni.showModal({
									title: this.translateSys("tip"),
									content: result.info,
									showCancel: false,
									confirmText: this.translateSys('close')
								});
							}
						}
					}

				}).catch(ex => {
					console.log(ex);
					let tip = typeof ex.errMsg == "string" ? ex.errMsg : ex
					uni.showModal({
						title: this.translateSys("error") + "8.1",
						content: this.translate("execute_after_ok_event_failed") +
							this.translateSys("comma") + tip,
						showCancel: false,
						confirmText: this.translateSys('close')
					});
				});
			},

			cancel(e) { //取消
				uni.navigateBack({
					delta: 1 //返回层数，2则上上页
				});
			},
			translate(t) {
				if (typeof this.$t == "function") return this.$t(`page.${t}`)
				else return t;
			},
			translateSys(t) {
				if (typeof this.$t == "function") return this.$t(`sys.${t}`)
				else return t;
			},
		},
	};
</script>
<style>
	.popup-content {
		@include flex;

	}

	.popup-height {
		@include height;
		/* width: 200px; */
	}
</style>
<style lang="scss">
	.uni-page-modal-5601 {

		display: flex;
		height: calc(100vh - 30rpx);
		width: 720rpx;
		flex-direction: column !important;
		padding: 15rpx;

		.view-header {
			display: flex;
			width: 100%;
			flex-direction: column;
		}


		.view-content {
			display: flex;
			flex: 1;
			width: 100%;
			flex-direction: column;
			min-height: 100px;
		}

		.dv-tab {
			width: calc(100% - 30rpx);
			padding: 0 15rpx;
		}

		.view-tabpage {
			width: 100%;
			flex: 1;
		}

		.view-tab-content {
			display: flex;
			flex: 1;
			width: calc(100% - 30rpx);
			padding: 10rpx 15rpx;
			flex-direction: column;
			overflow-y: auto;

		}

		.uni-panel-content {
			display: flex;
			width: 100%;
			height: 100%;
			flex-direction: column !important;
		}


		.view-bottom {
			display: flex;
			flex-direction: row;
			width: calc(100% - 30rpx);
			padding: 10rpx 15rpx 30rpx 15rpx;

			.btn-disabled {
				background-color: #ddd !important;
				color: #888 !important;
			}

			.btn-left {
				padding: 20rpx;
				line-height: 1.5;
				font-size: 38rpx;
				font-weight: bold;
				float: left;
				display: inline-block;

			}

			.btn-one {
				padding: 20rpx;
				line-height: 1.5;
				font-size: 38rpx;
				font-weight: bold;
				float: left;
				display: inline-block;
				width: 50%;
				margin-left: 25%;
			}

			.btn-right {
				padding: 20rpx;
				line-height: 1.5;
				font-size: 38rpx;
				font-weight: bold;
				float: right;
				display: inline-block;
			}

			.width-50 {
				width: 49%;
			}

			.width-32 {
				width: 32%;
				margin-left: 1%;
			}

			.width-30 {
				width: 30%;
				margin-left: 1%;
			}
		}

		.btn-warn {
			background: #ff2d1e;
			border: none;
			color: #fff;
		}

		.btn-cancel {
			background: #fff;
			color: #000;
		}

		.btn-primary {
			background: #27A6E1;
			border: none;
			color: #fff;
		}

		[nvue] uni-view {
			position: relative;
			border: 0 solid #000;
			box-sizing: border-box;
		}

		.uni-icon {
			/* border: 1px solid red; */
			width: 30rpx;
			font-family: uniicons;
			font-size: 40rpx;
			font-weight: 400;
			font-style: normal;
			/* width: 48rpx; */
			height: 48rpx;
			line-height: 48rpx;
			color: #2d8cf0;
			cursor: pointer;
			display: inline-block;
			vertical-align: 18rpx;
		}

		.dv-panel {
			background-color: #efefef;
			padding: 10rpx 10rpx 10rpx 0px;
			border-radius: 12rpx;
			margin: 10rpx 0 20rpx 0;

			.dv-panel-form {
				padding: 0px;
				margin: 0;

				.uni-forms-item {
					padding-bottom: 5rpx;
					margin-bottom: 0;

					.uni-forms-item__label {
						height: 20px !important;
						padding: 0 10rpx 0 0 !important;
					}
				}

			}

			.dv-panel-button {
				width: 100%;
				text-align: left;
				min-height: 30rpx;
				padding-bottom: 10rpx;

				checkbox {
					padding-left: 20px;
					display: inline-block;
				}

				button {
					text-align: left;
					line-height: 1.5;
					border: none;
					font-size: 30rpx;
					margin-right: 10rpx;
					display: inline-block;
					float: right;
					text-align: center;
				}
			}

		}


		.logo {
			height: 100rpx;
			width: 460rpx;
			display: flex;
			margin: 38% auto;
		}

		.dv-border {
			border: 1px solid red;
		}

		.view-imagetext {
			text-align: center;
			width: calc(100% - 80rpx);
			padding: 20rpx 40rpx 0px 40rpx;
			height: calc(100% - 30rpx);
			overflow: hidden;
		}

		.view-imagetext .view-imagetext-uploadlist {
			padding: 30rpx 0px 10rpx 0px;
			vertical-align: middle;
			display: inline-block;
			width: 100%;
			height: 100%;
			text-align: center;
			line-height: 100%;
			border: 2rpx solid transparent;
			border-radius: 8rpx;
			overflow: hidden;
			background: #fff;
			position: relative;
		}

		.view-imagetext .txt-text {
			display: block;
			margin: 20rpx;
			font-weight: bold;
		}

		.view-detalist-centen {
			text-align: center;
			width: 100%;
		}

		.view-detalist-centen .txt-detalist {
			background: #94D5EF;
			display: block;
			width: 100%;
			font-size: 36rpx;
			line-height: 80rpx;
			font-weight: 500;
		}

		.panel-active {
			border: 2px solid red;
		}

		.bk-active {
			background-color: #D6FCB2;
		}

		.dv_select {
			display: inline-block;
			width: 66%;
			background: #FFF;
			border-radius: 0 !important;
			color: #2d8cf0;
			/* padding: 10rpx 8rpx 12rpx; */
			font-size: 34rpx;
			font-family: inherit;
			box-shadow: none !important;
			transition-duration: 0.1s;
			margin-top: 0rpx;
			vertical-align: 20rpx;

			.uni-select {
				border: 2rpx solid #ccc;
				border-radius: 0 !important;
				color: #2d8cf0;
			}

			.uni-select__input-text {
				color: #2d8cf0;
			}

		}


		.input-disabled {
			background-color: #f3f3f3 !important;
		}

		.demo-uni-col {
			height: 36px;
			border-radius: 5px;
		}

		.view-popup {
			position: relative;
		}

		.popup-content {
			// @include flex;
			align-items: center;
			justify-content: center;
			padding: 30rpx;
			background-color: #fff;
			/* height: 150px; */
			/* border: 1px solid red; */
		}

		.popup-cont {
			overflow-y: auto;
			/* border: 1px solid red; */
		}

		.popup-height {
			// @include height;
			/* width: 200px; */
		}

		.popup-header {
			font-size: 42rpx;
			font-weight: bold;
			margin: 20rpx 20rpx 0px 20rpx;
		}

		.view_popup_CheckList {
			margin-bottom: 20rpx;
		}

		.popup-footer {
			float: right;
			position: absolute;
			bottom: 10rpx;
			right: 20rpx;
		}

		button.btn_popup_add {
			width: 180rpx;
			margin-top: 50rpx;
			margin-right: 20rpx;
			padding: 15rpx;
			line-height: 1.5;
			background: #27A6E1;
			border: none;
			color: #fff;
			font-size: 38rpx;
			font-weight: bold;
			/* float: left; */
			display: inline-block;
		}

		button.btn_popup_cancel {
			width: 180rpx;
			margin-top: 50rpx;
			padding: 15rpx;
			line-height: 1.5;
			// background: #27A6E1;
			// border: none;
			// color: #fff;
			background: #fff;
			color: #000;
			font-size: 38rpx;
			font-weight: bold;
			/* float: right; */
			display: inline-block;
		}


	}
</style>